#!/usr/bin/python

__doc__ = """Boost Software License - Version 1.0 - August 17th, 2003

Permission is hereby granted, free of charge, to any person or organization
obtaining a copy of the software and accompanying documentation covered by
this license (the "Software") to use, reproduce, display, distribute,
execute, and transmit the Software, and to prepare derivative works of the
Software, and to permit third-parties to whom the Software is furnished to
do so, all subject to the following:

The copyright notices in the Software and this entire statement, including
the above license grant, this restriction and the following disclaimer,
must be included in all copies of the Software, in whole or in part, and
all derivative works of the Software, unless such copies or derivative
works are solely in the form of machine-executable object code generated by
a source language processor.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE, TITLE AND NON-INFRINGEMENT. IN NO EVENT
SHALL THE COPYRIGHT HOLDERS OR ANYONE DISTRIBUTING THE SOFTWARE BE LIABLE
FOR ANY DAMAGES OR OTHER LIABILITY, WHETHER IN CONTRACT, TORT OR OTHERWISE,
ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
DEALINGS IN THE SOFTWARE."""

import os
import patterns,gamefield

class finder:
    def __init__(self,field):
        self.patterns = patterns.patterns()
	self.field = field
	self.moves = []
	self.findmoves()
    
    def findmoves(self):
        for lineindex,line in enumerate(self.field.field):
	    for colindex,val in enumerate(line):
	        if val != '*' and val != '_':
    	            for pattern in self.patterns.pattern:
		        try:
		            #print val, str(val.isdigit()) , str(self.field.field[lineindex][colindex].isdigit())
			    firstpatlineindex = lineindex + pattern[0][0]
			    firstpatcolindex = colindex + pattern[0][1]
			    secondpatlineindex = lineindex + pattern[1][0]
			    secondpatcolindex = colindex + pattern[1][1]
			    if firstpatlineindex < 0 or firstpatcolindex < 0 or secondpatlineindex < 0 or secondpatcolindex < 0: continue
		            if (val == self.field.field[firstpatlineindex][firstpatcolindex] and \
			        val == self.field.field[lineindex + pattern[1][0]][colindex + pattern[1][1]]) or \
			       (val.isdigit() and \
			       self.field.field[firstpatlineindex][firstpatcolindex].isdigit() and \
			       self.field.field[secondpatlineindex][secondpatcolindex].isdigit()):
			        if pattern[2] == 1:
			            move = (lineindex + pattern[1][0],colindex + pattern[1][1],lineindex + +pattern[1][0] + pattern[3][0],colindex + pattern[1][1] + pattern[3][1])
			        elif pattern[2] == -1:
			            move = (lineindex,colindex,lineindex + pattern[3][0],colindex + pattern[3][1])
			        else:
			            assert False , "Wrong index on pattern!"

			        self.moves.append({'move': move,'indices' : ((lineindex,colindex),(firstpatlineindex,firstpatcolindex),(secondpatlineindex,secondpatcolindex)), 'pattern' : pattern,'val': val,'patt1val' :self.field.field[lineindex + pattern[0][0]][colindex + pattern[0][1]], "patt2val" : self.field.field[lineindex + pattern[1][0]][colindex + pattern[1][1]]   })
	

		        except IndexError:
		            continue

    def __repr__(self):
        string = str(self.field)
	string += "%(val)5s %(patt1val)5s %(patt2val)5s %(move)14s %(pattern)s\n" % {'val' : 'val1',
	                                                    'patt1val' : 'val2',
							    'patt2val' : 'val3',
							    'move'     : 'move',
							    'pattern'  : 'pattern'
							   }
	for found in self.moves:
	    string += "%(val)5s %(patt1val)5s %(patt2val)5s %(move)14s %(pattern)s\n" % found
	
	string += "Found: %d" % len(self.moves)
	return string

if __name__ == "__main__":
    field = gamefield.playground(os.getcwd() + "/testfield.dat")
    test = finder(field)
    print test

